Name:           pyftpdlib
Version:        1.4.0
Release:        4%{?dist}
Summary:        Python FTP server library

Group:          Development/Languages
License:        MIT
URL:            https://github.com/giampaolo/pyftpdlib
Source0:        https://github.com/giampaolo/pyftpdlib/archive/release-%{version}.tar.gz

# This is b583a745 from upstream, minus the parts increasing the version number
Patch0:         pyftpdlib-python3-sendfile.patch

BuildArch:      noarch
BuildRequires:  python-devel python-nose python-setuptools pysendfile
Requires:       pysendfile pyOpenSSL

%description
Python FTP server library provides a high-level portable interface to easily
write asynchronous FTP servers with Python. Based on asyncore framework
pyftpdlib is currently the most complete RFC-959 FTP server implementation
available for Python programming language.

%package -n python3-pyftpdlib
Summary:        FTP server library for Python 3
Group:          Development/Languages

# sendfile is not needed in Python 3, pyftpdlib will use os.sendfile instead
BuildRequires:  python3-devel python3-nose python3-setuptools
Requires:       python3-pyOpenSSL

%description -n python3-pyftpdlib
Python FTP server library provides a high-level portable interface to easily
write asynchronous FTP servers with Python. Based on asyncore framework
pyftpdlib is currently the most complete RFC-959 FTP server implementation
available for Python programming language.

This package provides pyftpdlib for Python 3.

%prep
%setup -qc
mv pyftpdlib-release-%{version} python2

pushd python2

%patch0 -p1 -b .python3-sendfile

# Remove exec bit from demo
chmod -x demo/*

# Remove shebang from libs
sed -i '1{\@^#!/usr/bin/env python@d}' %{name}/*.py
sed -i '1{\@^#!/usr/bin/env python@d}' %{name}/contrib/*.py

# Copy common doc files to the top directory
cp -pr CREDITS HISTORY.rst LICENSE README.rst demo ../
popd

cp -a python2 python3

%build
pushd python2
%{__python2} setup.py build
popd

pushd python3
%{__python3} setup.py build
popd

%install
pushd python2
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}
popd

pushd python3
%{__python3} setup.py install -O1 --skip-build --root %{buildroot}
popd

%check
pushd python2
PYTHONPATH=. %{__python2} test/test_ftpd.py
PYTHONPATH=. %{__python2} test/test_contrib.py
popd

pushd python3
PYTHONPATH=. %{__python3} test/test_ftpd.py
PYTHONPATH=. %{__python3} test/test_contrib.py
popd

%files
%license LICENSE
%doc CREDITS HISTORY.rst README.rst demo/ 
%{python2_sitelib}/pyftpdlib
%{python2_sitelib}/pyftpdlib-%{version}-*.egg-info

%files -n python3-pyftpdlib
%license LICENSE
%doc CREDITS HISTORY.rst README.rst demo/
%{python3_sitelib}/pyftpdlib
%{python3_sitelib}/pyftpdlib-%{version}-*.egg-info

%changelog
* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Mar 18 2015 David Shea <dshea@redhat.com> 1.4.0-3
- Add a python3 package.
- Use %%license for the license file

* Wed Dec 24 2014 Athmane Madjoudj <athmane@fedoraproject.org> 1.4.0-2
- Add deps on pyOpenSSL

* Wed Dec 24 2014 Athmane Madjoudj <athmane@fedoraproject.org> 1.4.0-1
- Update to 1.4.0
- Update spec file
- Enable the test suite

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Apr 10 2012 Silas Sewell <silas@sewell.org> - 0.7.0-1
- Update to 0.7.0

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Sun Jul 24 2011 Silas Sewell <silas@sewell.org> - 0.6.0-1
- Update to 0.6.0

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Jul 21 2010 David Malcolm <dmalcolm@redhat.com> - 0.5.2-2
- Rebuilt for https://fedoraproject.org/wiki/Features/Python_2.7/MassRebuild

* Wed Oct 21 2009 Silas Sewell <silas@sewell.ch> - 0.5.2-1
- Update to 0.5.2

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sat Mar 28 2009 Silas Sewell <silas@sewell.ch> - 0.5.1-4
- Fix various issues reported by rpmlint
- Remove INSTALL file

* Thu Mar 26 2009 Silas Sewell <silas@sewell.ch> - 0.5.1-3
- Update package name to conform to Fedora naming standards
- Remove unneeded requires
- Change define to global

* Thu Mar 12 2009 Silas Sewell <silas@sewell.ch> - 0.5.1-2
- Fix various rpmlint issues

* Tue Feb 24 2009 Silas Sewell <silas@sewell.ch> - 0.5.1-1
- Initial build
